/*
 * list.c
 * Simple Dir
 * Bernhard Rabe
 * 06.01.2005
 */
 
#include <windows.h>
#include <stdio.h>

static void ErrorExit(const char * msg, DWORD errno)
{
    LPVOID *errmsg;
    
    if (!FormatMessage( 
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM | 
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        errno,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
        (LPTSTR) &errmsg,
        0,
        NULL )
    )
    {
        fprintf(stderr,"FormatMessage\n");
        exit(2);
    }

    fprintf(stderr, "Fehler: %s:%s\n", msg, errmsg);
    LocalFree(errmsg);
    exit(errno);
}


int main(int argc, char *argv[])
{
    HANDLE hFirst;
    WIN32_FIND_DATA fData;
    BOOL found=FALSE;
    DWORD errno;
    
    char path[MAX_PATH+3];
        
    if(argc<2)
        /*use current directory*/
        sprintf(path,".\\*");
    else
        /*use user supplied directory*/
        sprintf(path,"%s\\*",argv[1]);

    hFirst=FindFirstFile(path,&fData);
     
    if(INVALID_HANDLE_VALUE==hFirst)
    {
	ErrorExit("FindFirstFile",GetLastError());
    }

	
    do{
          
        if(strlen(fData.cFileName)!=0)
        {
            printf("%s\t%s\n",(fData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)?"DIR":"",fData.cFileName);
        }
        else if(strlen(fData.cAlternateFileName)!=0)
        {
            printf("%s\t%s\n",(fData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)?"DIR":"",fData.cAlternateFileName);
        }
        else
            printf("::: kein Name verfuegbar :::\n");
              
	found=FindNextFile(hFirst,&fData);
    }while(found);

	
    if((errno=GetLastError())!=ERROR_NO_MORE_FILES)
    {
        ErrorExit("FindNextFile",errno);
    }
        
    if(!FindClose(hFirst))
    {
        ErrorExit("FindClose",GetLastError());
    }
    return 0;
}
